#! /bin/sh
#
# Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
#
#
ExitCode=0

# chk/add /etc/driver_aliases entries
# 	(will not be removed on backout)

DRVCLASS=${ROOTDIR}/etc/driver_classes
DRVALIAS=${ROOTDIR}/etc/driver_aliases
NAME2MAJOR=${ROOTDIR}/etc/name_to_major

update_alias ()
{
  alias=$1
  driver=$2
  
  # Add alias if needed
  grep "^${driver}[ 	][ 	]*${alias}" $DRVALIAS > /dev/null 2>&1
  if [ $? -ne 0 ]; then
    if [ ! -w $DRVALIAS ] ; then
      if [ $ExitCode -eq 0 ] ; then
        echo "${DRVALIAS} not writeable."  >&2
        echo "Failed to update." >&2
        ExitCode=1
      fi
    else
      echo "$driver $alias" >> $DRVALIAS
      if [ $? -ne 0 ] ; then
        echo "Failed to update $DRVALIAS with $driver $alias." >&2
        ExitCode=1
      fi
    fi
  fi
}


update_class ()
{
  class=$1
  driver=$2
  
  # Add class if needed
  grep "^${driver}[ 	][ 	]*${class}$" $DRVCLASS > /dev/null 2>&1
  if [ $? -ne 0 ]; then
    if [ ! -w $DRVCLASS ] ; then
      if [ $ExitCode -eq 0 ] ; then
        echo "${DRVCLASS} not writeable."  >&2
        echo "Failed to update." >&2
        ExitCode=1
      fi
    else
      echo "$driver $class" >> $DRVCLASS
      if [ $? -ne 0 ] ; then
        echo "Failed to update $DRVCLASS with $driver $class." >&2
        ExitCode=1
      fi
    fi
  fi
}


add_driver()
{
  driver=$1
  
  # Add driver if needed
  grep "^$driver[ 	]" $NAME2MAJOR > /dev/null 2>&1
  if [ $? -ne 0 ] ; then
    add_drv -b ${ROOTDIR} -m '* 0600 root sys' $driver 
    if [ $? -ne 0 ] ; then
      echo "Error: add_drv failed to add $driver." >&2
      ExitCode=1
    fi
  fi
}



# Update driver files
add_driver emlxs
update_alias '"pci10df,fc00"' emlxs
update_class fibre-channel emlxs
#

# Update San_drivers
TMPF=/tmp/sand_$$
Dst=${ROOTDIR}/opt/SUNWsan/etc/san_drivers
Sav=${PKGDB}/SUNWsan/${PatchNum}.sav 
touch $Sav

idate=`date +%y/%m/%d`

while read driver dpkg desc ; do

   dfile=${ROOTDIR}${driver}

   if [ -f $dfile ] ; then

      siz=`ls -l ${dfile} | nawk '{print $5}'`
      cksum=`sum ${dfile} | nawk '{print $1}'`
   
      sd_line=`printf "%s:%s:%s:%s:%s:%s\n" \
      "$driver" "$desc" "$siz" "$cksum" "$idate" "$PatchNum"`

      osd_line=`grep \^${driver}\: $Dst`
   
      if [ -z "$osd_line" ] ; then
	    echo $sd_line >> $Dst
      else
	    echo "$osd_line" >> $Sav
	    sed -e 's+^'$driver':.*+'$sd_line'+' $Dst > $TMPF
   	    mv $TMPF $Dst
      fi
   fi

done < ${patchdir}/san_drivers

 
# Archive this patch 
# 
# 
if [ -f $ROOTDIR/opt/SUNWsan/patches/patchconf ]; then 

 . $ROOTDIR/opt/SUNWsan/patches/patchconf 

 if [ $patch_archive = yes ] ; then 
   if [ ! -f $ROOTDIR/opt/SUNWsan/patches/${PatchNum}.tar.Z ]; then

     cd `dirname ${patchdir}`
     TMPF=/tmp/$$_${PatchNum}.tar

     tar cf $TMPF `basename ${patchdir}`
     compress $TMPF

     # Remove older versions
     for P in `ls $ROOTDIR/opt/SUNWsan/patches/${PatchBase}* 2> /dev/null`
     do
	 rm -f $P
     done

     # check for space
     FreeSP=`df -b $ROOTDIR/opt/SUNWsan/patches | tail -1 | nawk '{print $2}'`
     TarSize=`du -k $TMPF.Z`

     if [ $FreeSP -gt $TarSize ]; then
        mv $TMPF.Z $ROOTDIR/opt/SUNWsan/patches/${PatchNum}.tar.Z
     else
        echo "Warning: Not enough space available in $ROOTDIR/opt/SUNWsan/patches to archive patch $PatchNum."
 	echo "To avoid seeing this warning message in the future; either increase disk space or turn off patch archiving in $ROOTDIR/opt/SUNWsan/patches/patchconf"
	echo "Patch archiving is an optional service used for upgrade recovery"
     fi
   fi 
 fi
fi 

exit $ExitCode 

